routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect('/home');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::get('/play', 'PlayController@index')->name('play');
Route::get('/join', 'JoinController@index')->name('join');
Route::get('/privacy', 'GdprController@index')->name('privacy');
Route::get('/search', 'SearchController@index')->name('search.index');

Route::resource('albums', 'AlbumController');
Route::resource('artists', 'ArtistController');
Route::resource('songs', 'SongController');
Route::get('/{type}/{id}/playlist', 'PlaylistController@addToPlaylist')->name('playlist.addToPlaylist');
Route::put('/{type}/{id}/playlist', 'PlaylistController@addToPlaylist')->name('playlist.addToPlaylist');

Route::post('/songs/{id}/queue', 'SongController@enqueue')->name('songs.enqueue');
Route::delete('/songs/{id}/queue', 'SongController@dequeue')->name('songs.dequeue');
Route::delete('/queue', 'SongController@emptySession')->name('songs.flush');

Route::resource('playlists', 'PlaylistController');


Route::resource('profile', 'ProfileController', [
    'only' => ['edit', 'update', 'destroy'],
    'parameters' => ['profile' => 'user']
]);
Route::put('/profile/{id}/theme', 'ProfileController@updateTheme')->name('profile.updateTheme');

/**
 * Redirection
 */
Route::any('{query}', function () {
    return redirect('/home');
})->where('query', '.*');

resources/views/partials/add_generic_to_playlist.blade.php
<div class="modal-header">
    <h2 class="modal-title text-white align-self-center m-0">{{ __('Add') }} @if(isset($model->name)) {{$model->name}} @else {{$model->title}} @endif {{ __('to playlist(s)') }}</h2>
</div>
<div class="modal-body">
    <form class="mt-2" action="{{route('playlist.addToPlaylist', [$type, $model->id])}}" method="POST">
        @method('PUT')
        @csrf
        <div class="form-group">
            <select class="custom-select" multiple name="playlist_id[]">
                @foreach($playlists as $playlist)
                    <option value="{{$playlist->id}}">{{ $playlist->name }}</option>
                @endforeach
                @admin
                @foreach($public_playlists as $playlist)
                    <option value="{{$playlist->id}}">{{ $playlist->name }}</option>
                @endforeach
                @endadmin
            </select>
            <input type="hidden" value="add" name="action">
        </div>

        <div class="form-group float-right">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">{{__('Close')}}</button>
            <button type="submit" class="btn btn-primary">
                {{ __('Add') }}
            </button>
        </div>
    </form>
</div>

resources/views/partials/iframe-tab.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}"></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body style="background: none transparent; height: 100%; overflow-x: hidden"
      class="@if(!Auth::check() || Auth::user()->theme === 'sombre') theme-dark @else theme-light @endif">
<div id="appIframe">
    <main>
        <form action="#" method="GET">
            <div class="row">
                <div class="col-md-10 col-7">
                    <form action="{{route('search.index')}}" method="POST">
                        <div class="input-group border-search rounded">
                            <div class="input-group-prepend">
                            <span class="input-group-text bg-transparent"
                                  id="basic-addon1">
                                @svg('solid/search', 'icon-sm icon-white')
                            </span>
                            </div>
                            <input type="text" class="form-control bg-transparent text-white"
                                   placeholder="{{__('Search')}}..." name="q"/>
                        </div>
                    </form>
                </div>
                <div class="col-md-2 col-5">
                    @guest
                        <a class="cursor-pointer float-right" href="#"
                           onclick='window.top.location.href = "{{ route('login') }}";'>{{ __('Login') }}</a>
                    @else
                        <div class="dropdown float-right">
                            <a id="navbarDropdown" class="nav-link dropdown-toggle text-white" href="#" role="button"
                               data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                {{ Auth::user()->username }} <span class="caret"></span>
                            </a>

                            <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                <a class="dropdown-item" href="#"
                                   onclick='window.top.location.href = "{{ route('profile.edit', Auth::user()->id) }}";'>
                                    {{ __('My profile') }}
                                </a>

                                <a class="dropdown-item" href="#" onclick="logout()">
                                    {{ __('Logout') }}
                                </a>

                                <form id="logout-form" action="{{ route('logout') }}" method="POST"
                                      style="display: none;">
                                    @csrf
                                    <input type="submit" value="Logout"/>
                                </form>
                            </div>
                        </div>
                    @endguest
                </div>
            </div>
        </form>

        <div id="lobby_navbar" style="position: relative;">
            <ul id="lobby_navbar_ul" class="nav nav-tabs border-0 mt-3">

                <li class="nav-item w-25 text-center">
                    <a class="nav-link @if(preg_match('/songs/',Request::path())) impulsy-active @endif"
                       href="{{route('songs.index')}}">@svg('icon_note')</a>
                </li>
                <li class="nav-item w-25 text-center">
                    <a class="nav-link @if(preg_match('/albums/',Request::path())) impulsy-active @endif"
                       href="{{route('albums.index')}}">@svg('icon_album')</a>
                </li>
                <li class="nav-item w-25 text-center">
                    <a class="nav-link @if(preg_match('/artists/',Request::path())) impulsy-active @endif"
                       href="{{route('artists.index')}}">@svg('icon_artist')</a>
                </li>
                <li class="nav-item w-25 text-center">
                    <a class="nav-link @if(preg_match('/playlists/',Request::path())) impulsy-active @endif"
                       href="{{route('playlists.index')}}">@svg('icon_playlist')</a>
                </li>
            </ul>
        </div>
        <div class="tab-content">
            <div class="tab-pane active">@yield('tab')</div>
        </div>
    </main>
</div>
@yield('scripts')
@include('partials.script-delete', ['text' => __('Delete?')])
@include('partials.modal-template')
<script>
    function queue(songs) {
        for (let i = 0; i < songs.length; i++) {
            enqueue("/songs/" + songs[i] + "/queue")
        }
    }

    function playAll(songs) {
        for (let i = 0; i < songs.length; i++) {
            if (i === 0) {
                play("/songs/" + songs[i] + "/queue")
            } else {
                enqueue("/songs/" + songs[i] + "/queue")
            }
        }
    }

    function play(href) {
        let data = {href: href};
        let event = new CustomEvent('play', {detail: data});
        window.parent.document.dispatchEvent(event);
    }

    function enqueue(href) {
        let data = {href: href};
        let event = new CustomEvent('enqueue', {detail: data});
        window.parent.document.dispatchEvent(event);
    }

    function logout() {
        const logout = $('#logout-form');
        logout.appendTo($('main'));
        logout.submit();
    }

    function ajaxLoad(filename, content) {
        content = typeof content !== 'undefined' ? content : 'content';
        $.ajax({
            type: "GET",
            url: filename,
            contentType: false,
            success: function (data) {
                $("#" + content).html(data);
            },
            error: function (xhr, status, error) {
                console.log(error);
                console.log(xhr);
                alert(xhr.responseText);
            }
        });
    }

    $('#modalForm').on('show.bs.modal', function (event) {
        let button = $(event.relatedTarget);
        ajaxLoad(button.data('href'), 'modal_content');
    });

    toastr.options.positionClass = 'toast-bottom-right';
    toastr.options.preventDuplicates = true;
</script>
<script>
    const nav_underline = document.createElement('div');
    const impulsy_active = document.getElementsByClassName('impulsy-active')[0];
    const lobby_navbar = document.getElementById('lobby_navbar');
    let formerPosition = impulsy_active.getBoundingClientRect().left;

    nav_underline.setAttribute('class', 'nav_underline w-25');
    nav_underline.setAttribute('style', `left: ${formerPosition}px;`);
    lobby_navbar.appendChild(nav_underline);

    bindEvent(window, 'resize', () => {
        formerPosition = impulsy_active.getBoundingClientRect().left;
        nav_underline.setAttribute('style', `left:${formerPosition}px;`);
    });

    const lobby_navbar_ul = document.getElementById('lobby_navbar_ul');
    lobby_navbar_ul.childNodes.forEach(liElement => {
        if (liElement.firstChild != impulsy_active) {
            bindEvent(liElement, 'mouseenter', (e) => {
                nav_underline.setAttribute('style', `left:${e.srcElement.getBoundingClientRect().left}px;`);
            });
            bindEvent(liElement, 'mouseleave', (e) => {
                nav_underline.setAttribute('style', `left:${formerPosition}px;`);
            });
        }
    });
</script>
</body>
</html>

resources/views/partials/modal-template.blade.php
<div class="modal fade" id="modalForm" tabindex="-1" role="dialog" data-backdrop="static">
    <div class="modal-dialog" role="document">
        <div class="modal-content t100 rounded" id="modal_content"></div>
    </div>
</div>

resources/views/partials/script-bpm.blade.php
<script>
    let AudioContext = window.AudioContext // Default
        || window.webkitAudioContext // Safari and old versions of Chrome
        || false;
    let context = null;

    if (AudioContext) {
        context = new AudioContext();

        function readFile(file) {
            let input = file.target;
            let reader = new FileReader();
            let buffer = null;
            let fileName = input.files[0].name;
            $('.custom-file-label').html(fileName);

            getMetaData(input.files[0]);
            reader.readAsArrayBuffer(input.files[0]);
            $("#submitForm").attr("disabled", true);
            $("#spin1,#spin2").removeClass("d-none");
            $("#spin_upload").addClass("d-none");
            reader.onloadend = function (e) {
                if (e.target.readyState === FileReader.DONE) {
                    buffer = e.target.result;
                    guessBPM(buffer);
                }
            };
        }

        function guessBPM(buffer){
            context.decodeAudioData(buffer, function (buffer) {
                guess(buffer)
                    .then(({bpm, offset}) => {
                        $('#songBpm').val(bpm);
                        $("#submitForm").attr("disabled", false);
                        $("#spin1,#spin2").addClass("d-none");
                        $("#spin_upload").removeClass("d-none");
                    })
                    .catch((err) => {
                        console.log(err);
                        $("#submitForm").attr("disabled", false);
                    });
            }, function (err) {
                console.log(err);
                $("#submitForm").attr("disabled", false);
            });
        }

        function getMetaData(blob){
            musicMetadata.parseBlob(blob).then(musicMetadata => {
                $('#artist').val(musicMetadata.common.artist);
                $('#album').val(musicMetadata.common.album);
                if(!musicMetadata.common.hasOwnProperty('title')){
                    $('#title').val(blob.name);
                } else {
                    $('#title').val(musicMetadata.common.title);
                }
            });
        }
    } else {
        // Web Audio API is not supported
        // Alert the user
        alert("Sorry, but the Web Audio API is not supported by your browser. Please, consider upgrading to the latest version or downloading Google Chrome or Mozilla Firefox");
    }
</script>

resources/views/partials/script-delete.blade.php
<script>
    $(() => {
        $.ajaxSetup({
            headers: {'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')}
        });

        $('a.delete').click((e) => {
            let that = $(e.currentTarget);
            e.preventDefault();
            Swal.fire({
                title: '{{ $text }}',
                type: 'error',
                showCancelButton: true,
                confirmButtonColor: '#DD6B55',
                confirmButtonText: '@lang('Yes')',
                cancelButtonText: '@lang('No')'
            }).then((result) => {
                if (result.value) {
                    $.ajax({
                        url: that.attr('href'),
                        type: 'DELETE'
                    }).done(() => {
                        location.reload();
                    }).fail(() => {
                        Swal.fire(
                            'Erreur',
                            'Erreur serveur, veuillez réessayer ultérieurement.',
                            'warning'
                        )
                    })
                }
            })
        })
    })
</script>